#define MAJOR(dev)	((unsigned int) ((dev) >> MINORBITS))
#define MINOR(dev)	((unsigned int) ((dev) & MINORMASK))
#define HASHDEV(dev)	((unsigned int) (dev))
#define NODEV		0
#define MKDEV(ma,mi)	(((ma) << MINORBITS) | (mi))
#define B_FREE		0xffff		/* yuk */

extern const char * kdevname(kdev_t);	/* note: returns pointer to static data! */

/* 2.5.x compatibility */
#define mk_kdev(a,b)	MKDEV(a,b)
#define major(d)	MAJOR(d)
#define minor(d)	MINOR(d)
#define kdev_same(a,b)	((a) == (b))
#define kdev_none(d)	(!(d))
#define kdev_val(d)	((unsigned int)(d))
#define val_to_kdev(d)	((kdev_t)(d))

static inline kdev_t to_kdev_t(int dev)
{
        int major, minor;
#if 0
        major = (dev >> 16);
        if (!major) {
                major = (dev >> 8);
                minor = (dev & 0xff);
        } else
                minor = (dev & 0xffff);
#else
        major = (dev >> 8);
        minor = (dev & 0xff);
#endif
        return MKDEV(major, minor);
}
